/*
 * Intel ACPI Component Architecture
 * AML/ASL+ Disassembler version 20161210-64(RM)
 * Copyright (c) 2000 - 2016 Intel Corporation
 * 
 * Disassembling to non-symbolic legacy ASL operators
 *
 * Disassembly of SSDT-5-IsctTabl.aml, Fri Feb  9 16:36:29 2018
 *
 * Original Table Header:
 *     Signature        "SSDT"
 *     Length           0x00000579 (1401)
 *     Revision         0x01
 *     Checksum         0xB5
 *     OEM ID           "Intel_"
 *     OEM Table ID     "IsctTabl"
 *     OEM Revision     0x00001000 (4096)
 *     Compiler ID      "INTL"
 *     Compiler Version 0x20120711 (538052369)
 */
DefinitionBlock ("", "SSDT", 1, "Intel_", "IsctTabl", 0x00001000)
{
    /*
     * External declarations were imported from
     * a reference file -- refs.txt
     */

    External (_GPE.MMTB, MethodObj)    // Imported: 0 Arguments
    External (_GPE.VHOV, MethodObj)    // Imported: 3 Arguments
    External (_SB_.IFFS.FFSS, UnknownObj)    // Warning: Unknown object
    External (_SB_.PCI0.GFX0.ASLC, FieldUnitObj)
    External (_SB_.PCI0.GFX0.ASLE, FieldUnitObj)
    External (_SB_.PCI0.GFX0.DD02._BCM, MethodObj)    // Imported: 1 Arguments
    External (_SB_.PCI0.GFX0.PARD, MethodObj)    // 0 Arguments
    External (_SB_.PCI0.GFX0.STAT, FieldUnitObj)
    External (_SB_.PCI0.GFX0.TCHE, FieldUnitObj)
    External (_SB_.PCI0.LPCB.H_EC.ECMD, MethodObj)    // Imported: 1 Arguments
    External (_SB_.PCI0.LPCB.H_EC.ECRD, MethodObj)    // Imported: 1 Arguments
    External (_SB_.PCI0.LPCB.H_EC.ECWT, MethodObj)    // Imported: 2 Arguments
    External (_SB_.PCI0.LPCB.H_EC.IBT1, IntObj)
    External (_SB_.PCI0.LPCB.H_EC.IBT2, UnknownObj)    // Warning: Unknown object
    External (_SB_.PCI0.LPCB.H_EC.LSTE, IntObj)
    External (_SB_.PCI0.LPCB.H_EC.WTMS, IntObj)
    External (_SB_.PCI0.PEG0.PEGP.SGPO, MethodObj)    // Imported: 2 Arguments
    External (_SB_.PCI0.SAT0.SDSM, MethodObj)    // Imported: 4 Arguments
    External (_SB_.PCI0.XHC_.RHUB.TPLD, MethodObj)    // Imported: 2 Arguments
    External (ICNF, FieldUnitObj)
    External (MDBG, MethodObj)    // Imported: 1 Arguments

    Scope (\_SB)
    {
        Device (IAOE)
        {
            OperationRegion (ISCT, SystemMemory, 0xCDEC7E98, 0x0011)
            Field (ISCT, AnyAcc, Lock, Preserve)
            {
                WKRS,   8, 
                AOCE,   8, 
                FFSE,   8, 
                ITMR,   8, 
                ECTM,   32, 
                RCTM,   32, 
                GNPT,   32, 
                ATOW,   8
            }

            Name (_HID, "INT33A0")  // _HID: Hardware ID
            Name (_UID, Zero)  // _UID: Unique ID
            Name (IBT1, Zero)
            Name (IBT2, Zero)
            Name (INSB, Zero)
            Name (IMDS, Zero)
            Name (IWDT, Zero)
            Method (GABS, 0, NotSerialized)
            {
                Return (ICNF)
            }

            Method (GAOS, 0, NotSerialized)
            {
                Return (Or (And (IBT1, One), And (IMDS, 0x06)))
            }

            Method (SAOS, 1, NotSerialized)
            {
                If (And (\_SB.PCI0.GFX0.TCHE, 0x0100))
                {
                    If (LAnd (LAnd (And (IBT1, One), LNot (And (Arg0, One))), And (\_SB.IAOE.WKRS, 0x10)))
                    {
                        If (LNot (\_SB.PCI0.GFX0.PARD ()))
                        {
                            Store (And (\_SB.PCI0.GFX0.STAT, 0xFFFFFFFC), \_SB.PCI0.GFX0.STAT)
                            Store (Or (\_SB.PCI0.GFX0.ASLC, 0x0100), \_SB.PCI0.GFX0.ASLC)
                            Store (One, \_SB.PCI0.GFX0.ASLE)
                        }
                    }
                }

                Store (And (Arg0, 0x06), IMDS)
                Or (And (IBT1, 0xFE), And (Arg0, One), IBT1)
                If (LEqual (ITMR, Zero))
                {
                    \_SB.PCI0.LPCB.H_EC.ECWT (IBT1, RefOf (\_SB.PCI0.LPCB.H_EC.IBT1))
                    \_SB.PCI0.LPCB.H_EC.ECMD (0x2B)
                }
            }

            Method (GANS, 0, NotSerialized)
            {
                Return (INSB)
            }

            Method (SANS, 1, NotSerialized)
            {
                Store (And (Arg0, One), INSB)
            }

            Method (GWLS, 0, NotSerialized)
            {
                And (IBT1, 0x0E, Local0)
                If (LEqual (ITMR, Zero))
                {
                    Or (Local0, Or (\_SB.PCI0.LPCB.H_EC.ECRD (RefOf (\_SB.PCI0.LPCB.H_EC.IBT2)), One), Local0)
                }

                Return (Local0)
            }

            Method (SWLS, 1, NotSerialized)
            {
                Or (And (IBT1, 0xF1), And (Arg0, 0x0E), IBT1)
                If (LEqual (ITMR, Zero))
                {
                    Or (And (\_SB.PCI0.LPCB.H_EC.ECRD (RefOf (\_SB.PCI0.LPCB.H_EC.IBT1)), 0xF1), And (Arg0, 0x0E), Local0)
                    If (CondRefOf (\_SB.IFFS.FFSS))
                    {
                        If (LAnd (And (\_SB.IFFS.FFSS, 0x03), And (Arg0, 0x02)))
                        {
                            Or (Local0, 0x04, Local0)
                        }
                    }

                    \_SB.PCI0.LPCB.H_EC.ECWT (Local0, RefOf (\_SB.PCI0.LPCB.H_EC.IBT1))
                    \_SB.PCI0.LPCB.H_EC.ECMD (0x2B)
                }
            }

            Method (GWWS, 0, NotSerialized)
            {
                ShiftRight (And (IBT1, 0x70), 0x03, Local0)
                If (LEqual (ITMR, Zero))
                {
                    Or (Local0, ShiftRight (Or (\_SB.PCI0.LPCB.H_EC.ECRD (RefOf (\_SB.PCI0.LPCB.H_EC.IBT2)), 0x02), One), Local0)
                }

                Return (Local0)
            }

            Method (SWWS, 1, NotSerialized)
            {
                Or (And (IBT1, 0x8F), ShiftLeft (And (Arg0, 0x0E), 0x03), IBT1)
                If (LEqual (ITMR, Zero))
                {
                    Or (And (\_SB.PCI0.LPCB.H_EC.ECRD (RefOf (\_SB.PCI0.LPCB.H_EC.IBT1)), 0x8F), ShiftLeft (And (Arg0, 0x0E), 0x03), Local0)
                    If (CondRefOf (\_SB.IFFS.FFSS))
                    {
                        If (LAnd (And (\_SB.IFFS.FFSS, 0x03), And (Arg0, 0x02)))
                        {
                            Or (Local0, 0x20, Local0)
                        }
                    }

                    \_SB.PCI0.LPCB.H_EC.ECWT (Local0, RefOf (\_SB.PCI0.LPCB.H_EC.IBT1))
                    \_SB.PCI0.LPCB.H_EC.ECMD (0x2B)
                }
            }

            Method (SASD, 1, Serialized)
            {
                If (LAnd (And (ICNF, 0x10), LGreater (Arg0, Zero)))
                {
                    If (LEqual (ITMR, One))
                    {
                        Store (Arg0, RCTM)
                    }
                    Else
                    {
                        Store (Arg0, ECTM)
                    }
                }
                ElseIf (LEqual (ITMR, One))
                {
                    Store (Zero, RCTM)
                }
                Else
                {
                    Store (Zero, ECTM)
                    \_SB.PCI0.LPCB.H_EC.ECWT (Zero, RefOf (\_SB.PCI0.LPCB.H_EC.WTMS))
                }
            }

            Method (GPWR, 0, NotSerialized)
            {
                If (And (WKRS, 0x2F))
                {
                    Return (And (WKRS, 0x2F))
                }
                Else
                {
                    Return (Zero)
                }
            }

            Method (GPCS, 0, NotSerialized)
            {
                If (LEqual (ITMR, Zero))
                {
                    Return (And (\_SB.PCI0.LPCB.H_EC.ECRD (RefOf (\_SB.PCI0.LPCB.H_EC.LSTE)), One))
                }
                Else
                {
                    Return (One)
                }
            }

            Method (GAWD, 0, NotSerialized)
            {
                Return (IWDT)
            }

            Method (SAWD, 1, NotSerialized)
            {
                Store (Arg0, IWDT)
            }
        }
    }
}

